// USBVAC^[tF[X(CDCNX)USBڑԊOR(wK@\͍폜)
//
// gFWindowsŊwKԊO߃f[^16i(code)foCXɗނ
// 쐬RFHIDNẌɕs̂OS邩
// x[XƂt@[EFA\[X̃o[WF2.1.5
// gpCuFMicrochip Libraries for Applications v2013-06-15
// 2014. 10. 19 by disklessfun


// USB IR REMOCON KIT
//	ver 2.1.D	2014. 10. 11 PIC18F2550ȏ̃foCXpB2.1.Bł36oCgƓdtH[}bgOHGAR͌Ήł͊SΉBGARɂΉB
//                           2.1.Cō̗p̓ŃGARWX-F01EΉǉBver2.1.5őΉŃGAR̃f[^̒20oCgWX-F01Eł18oCgB[_R[hقȂB
//                           2.1.BA2.1.CƈقȂAΉ̐ԊOtH[}bg폜̂͂ȂB
//	ver 2.1.5	2014. 08. 31 ŃGAREGARΉA2.1.2A2.1.4ňꕔ̉ƓdtH[}bgTMYƌFĂoOCBeʂ̖ŊgtH[}bgpƂȂ̂őMpݒc[Ver1nɂ͔ΉɁB by disklessfun
//	ver 2.1.4	2014. 05. 17 EOmAV@(NECtH[}bg)A\j[ATMY(ƓdtH[}bg)AۑPd@Ή by disklessfun
//	ver 2.1.2	2014. 04. 29 (ÂH)SONYATMY(ƓdtH[}bg)AۑPd@Ή by disklessfun
//	ver 2.1	2013D03D26 DAIKIN 33kHzΉ
//	ver 2	2013D03D08 GARΉ
//	ver 1	


/********************************************************************
 FileName:      main.c
 Dependencies:  See INCLUDES section
 Processor:     PIC18, PIC24, dsPIC, and PIC32 USB Microcontrollers
 Hardware:      This demo is natively intended to be used on Microchip USB demo
                boards supported by the MCHPFSUSB stack.  See release notes for
                support matrix.  This demo can be modified for use on other 
                hardware platforms.
 Complier:      Microchip C18 (for PIC18), XC16 (for PIC24/dsPIC), XC32 (for PIC32)
 Company:       Microchip Technology, Inc.

 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************
 File Description:

 Change History:
  Rev   Description
  ----  -----------------------------------------
  1.0   Initial release
  2.1   Updated for simplicity and to use common coding style
  2.8   Improvements to USBCBSendResume(), to make it easier to use.
        Added runtime check to avoid buffer overflow possibility if 
        the USB IN data rate is somehow slower than the UART RX rate.
  2.9b  Added support for optional hardware flow control.
  2.9f  Adding new part support   
  2.9j  Updates to support new bootloader features (ex: app version 
        fetching).
********************************************************************/

/** INCLUDES *******************************************************/
#include <timers.h>
#include <pwm.h>
#include "./USB/usb.h"
#include "./USB/usb_function_cdc.h"

#include "HardwareProfile.h"

#if defined (__C30__) || defined(__C32__) || defined __XC16__
    #include "./uart2.h"
#endif

/** CONFIGURATION **************************************************/
#if defined(PICDEM_FS_USB)      // Configuration bits for PICDEM FS USB Demo Board (based on PIC18F4550)
        #pragma config PLLDIV   = 5         // (20 MHz crystal on PICDEM FS USB board)
//        #pragma config PLLDIV   = 2         // (8 MHz crystal on PICDEM FS USB board)
        #pragma config CPUDIV   = OSC1_PLL2   
        #pragma config USBDIV   = 2         // Clock source from 96MHz PLL/2
        #pragma config FOSC     = HSPLL_HS
        #pragma config FCMEN    = OFF
        #pragma config IESO     = OFF
        #pragma config PWRT     = OFF
        #pragma config BOR      = ON
        #pragma config BORV     = 3
        #pragma config VREGEN   = ON      //USB Voltage Regulator
        #pragma config WDT      = OFF
        #pragma config WDTPS    = 32768
        #pragma config MCLRE    = ON
        #pragma config LPT1OSC  = OFF
        #pragma config PBADEN   = OFF
//      #pragma config CCP2MX   = ON
        #pragma config STVREN   = ON
        #pragma config LVP      = OFF
//      #pragma config ICPRT    = OFF       // Dedicated In-Circuit Debug/Programming
        #pragma config XINST    = OFF       // Extended Instruction Set
        #pragma config CP0      = OFF
        #pragma config CP1      = OFF
//      #pragma config CP2      = OFF
//      #pragma config CP3      = OFF
        #pragma config CPB      = OFF
//      #pragma config CPD      = OFF
        #pragma config WRT0     = OFF
        #pragma config WRT1     = OFF
//      #pragma config WRT2     = OFF
//      #pragma config WRT3     = OFF
        #pragma config WRTB     = OFF       // Boot Block Write Protection
        #pragma config WRTC     = OFF
//      #pragma config WRTD     = OFF
        #pragma config EBTR0    = OFF
        #pragma config EBTR1    = OFF
//      #pragma config EBTR2    = OFF
//      #pragma config EBTR3    = OFF
        #pragma config EBTRB    = OFF

#elif defined(PICDEM_FS_USB_K50)
        #pragma config PLLSEL   = PLL3X     // 3X PLL multiplier selected
        #pragma config CFGPLLEN = OFF       // PLL turned on during execution
        #pragma config CPUDIV   = NOCLKDIV  // 1:1 mode (for 48MHz CPU)
        #pragma config LS48MHZ  = SYS48X8   // Clock div / 8 in Low Speed USB mode
        #pragma config FOSC     = INTOSCIO  // HFINTOSC selected at powerup, no clock out
        #pragma config PCLKEN   = OFF       // Primary oscillator driver
        #pragma config FCMEN    = OFF       // Fail safe clock monitor
        #pragma config IESO     = OFF       // Internal/external switchover (two speed startup)
        #pragma config nPWRTEN  = OFF       // Power up timer
        #pragma config BOREN    = SBORDIS   // BOR enabled
        #pragma config nLPBOR   = ON        // Low Power BOR
        #pragma config WDTEN    = SWON      // Watchdog Timer controlled by SWDTEN
        #pragma config WDTPS    = 32768     // WDT postscalar
        #pragma config PBADEN   = OFF       // Port B Digital/Analog Powerup Behavior
        #pragma config SDOMX    = RC7       // SDO function location
        #pragma config LVP      = OFF       // Low voltage programming
        #pragma config MCLRE    = ON        // MCLR function enabled (RE3 disabled)
        #pragma config STVREN   = ON        // Stack overflow reset
        //#pragma config ICPRT  = OFF       // Dedicated ICPORT program/debug pins enable
        #pragma config XINST    = OFF       // Extended instruction set

#elif defined(PIC18F87J50_PIM)				// Configuration bits for PIC18F87J50 FS USB Plug-In Module board
        #pragma config XINST    = OFF   	// Extended instruction set
        #pragma config STVREN   = ON      	// Stack overflow reset
        #pragma config PLLDIV   = 3         // (12 MHz crystal used on this board)
        #pragma config WDTEN    = OFF      	// Watch Dog Timer (WDT)
        #pragma config CP0      = OFF      	// Code protect
        #pragma config CPUDIV   = OSC1      // OSC1 = divide by 1 mode
        #pragma config IESO     = OFF      	// Internal External (clock) Switchover
        #pragma config FCMEN    = OFF      	// Fail Safe Clock Monitor
        #pragma config FOSC     = HSPLL     // Firmware must also set OSCTUNE<PLLEN> to start PLL!
        #pragma config WDTPS    = 32768
//      #pragma config WAIT     = OFF      	// Commented choices are
//      #pragma config BW       = 16      	// only available on the
//      #pragma config MODE     = MM      	// 80 pin devices in the 
//      #pragma config EASHFT   = OFF      	// family.
        #pragma config MSSPMSK  = MSK5
//      #pragma config PMPMX    = DEFAULT
//      #pragma config ECCPMX   = DEFAULT
        #pragma config CCP2MX   = DEFAULT   
        
// Configuration bits for PIC18F97J94 PIM and PIC18F87J94 PIM
#elif defined(PIC18F97J94_PIM) || defined(PIC18F87J94_PIM)
        #pragma config STVREN   = ON      	// Stack overflow reset
        #pragma config XINST    = OFF   	// Extended instruction set
        #pragma config BOREN    = ON        // BOR Enabled
        #pragma config BORV     = 0         // BOR Set to "2.0V" nominal setting
        #pragma config CP0      = OFF      	// Code protect disabled
        #pragma config FOSC     = FRCPLL    // Firmware should also enable active clock tuning for this setting
        #pragma config SOSCSEL  = LOW       // SOSC circuit configured for crystal driver mode
        #pragma config CLKOEN   = OFF       // Disable clock output on RA6
        #pragma config IESO     = OFF      	// Internal External (clock) Switchover
        #pragma config PLLDIV   = NODIV     // 4 MHz input (from 8MHz FRC / 2) provided to PLL circuit
        #pragma config POSCMD   = NONE      // Primary osc disabled, using FRC
        #pragma config FSCM     = CSECMD    // Clock switching enabled, fail safe clock monitor disabled
        #pragma config WPDIS    = WPDIS     // Program memory not write protected
        #pragma config WPCFG    = WPCFGDIS  // Config word page of program memory not write protected
        #pragma config IOL1WAY  = OFF       // IOLOCK can be set/cleared as needed with unlock sequence
        #pragma config LS48MHZ  = SYSX2     // Low Speed USB clock divider
        #pragma config WDTCLK   = LPRC      // WDT always uses INTOSC/LPRC oscillator
        #pragma config WDTEN    = ON        // WDT disabled; SWDTEN can control WDT
        #pragma config WINDIS   = WDTSTD    // Normal non-window mode WDT.
        #pragma config VBTBOR   = OFF       // VBAT BOR disabled


#elif defined(PIC18F46J50_PIM) || defined(PIC18F47J53_PIM)
     #pragma config WDTEN = OFF          //WDT disabled (enabled by SWDTEN bit)
     #pragma config PLLDIV = 3           //Divide by 3 (12 MHz oscillator input)
     #pragma config STVREN = ON          //stack overflow/underflow reset enabled
     #pragma config XINST = OFF          //Extended instruction set disabled
     #pragma config CPUDIV = OSC1        //No CPU system clock divide
     #pragma config CP0 = OFF            //Program memory is not code-protected
     #pragma config OSC = HSPLL          //HS oscillator, PLL enabled, HSPLL used by USB
     //#pragma config T1DIG = ON           //Sec Osc clock source may be selected
     //#pragma config LPT1OSC = OFF        //high power Timer1 mode
     #pragma config FCMEN = OFF          //Fail-Safe Clock Monitor disabled
     #pragma config IESO = OFF           //Two-Speed Start-up disabled
     #pragma config WDTPS = 32768        //1:32768
     #pragma config DSWDTOSC = INTOSCREF //DSWDT uses INTOSC/INTRC as clock
     #pragma config RTCOSC = T1OSCREF    //RTCC uses T1OSC/T1CKI as clock
     #pragma config DSBOREN = OFF        //Zero-Power BOR disabled in Deep Sleep
     #pragma config DSWDTEN = OFF        //Disabled
     #pragma config DSWDTPS = 8192       //1:8,192 (8.5 seconds)
     #pragma config IOL1WAY = OFF        //IOLOCK bit can be set and cleared
     #pragma config MSSP7B_EN = MSK7     //7 Bit address masking
     #pragma config WPFP = PAGE_1        //Write Protect Program Flash Page 0
     #pragma config WPEND = PAGE_0       //Start protection at page 0
     #pragma config WPCFG = OFF          //Write/Erase last page protect Disabled
     #pragma config WPDIS = OFF          //WPFP[5:0], WPEND, and WPCFG bits ignored 
#elif defined(LOW_PIN_COUNT_USB_DEVELOPMENT_KIT)
        #pragma config CPUDIV = NOCLKDIV
        #pragma config USBDIV = OFF
        #pragma config FOSC   = HS
        #pragma config PLLEN  = ON
        #pragma config FCMEN  = OFF
        #pragma config IESO   = OFF
        #pragma config PWRTEN = OFF
        #pragma config BOREN  = ON
        #pragma config BORV   = 30
        #pragma config WDTEN  = OFF
        #pragma config WDTPS  = 32768
        #pragma config MCLRE  = OFF
        #pragma config HFOFST = OFF
        #pragma config STVREN = ON
        #pragma config LVP    = OFF
        #pragma config XINST  = OFF
        #pragma config BBSIZ  = OFF
        #pragma config CP0    = OFF
        #pragma config CP1    = OFF
        #pragma config CPB    = OFF
        #pragma config WRT0   = OFF
        #pragma config WRT1   = OFF
        #pragma config WRTB   = OFF
        #pragma config WRTC   = OFF
        #pragma config EBTR0  = OFF
        #pragma config EBTR1  = OFF
        #pragma config EBTRB  = OFF       

#elif	defined(PIC16F1_LPC_USB_DEVELOPMENT_KIT)
    // PIC 16F1459 fuse configuration:
    #if defined (USE_INTERNAL_OSC)  //Definition in the hardware profile
        __CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF & BOREN_ON & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
        __CONFIG(WRT_OFF & CPUDIV_NOCLKDIV & USBLSCLK_48MHz & PLLMULT_3x & PLLEN_ENABLED & STVREN_ON &  BORV_LO & LPBOR_OFF & LVP_ON);
    #else
        __CONFIG(FOSC_HS & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF & BOREN_ON & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
        __CONFIG(WRT_OFF & CPUDIV_NOCLKDIV & USBLSCLK_48MHz & PLLMULT_4x & PLLEN_ENABLED & STVREN_ON &  BORV_LO & LPBOR_OFF & LVP_ON);
    #endif

#elif defined(EXPLORER_16)
    #if defined(__PIC24FJ256GB110__)
        _CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & FWDTEN_OFF & ICS_PGx2) 
        _CONFIG2( PLL_96MHZ_ON & IESO_OFF  & FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS & FNOSC_PRIPLL & PLLDIV_DIV2 & IOL1WAY_ON)
    #elif defined(__PIC24FJ256GB210__)
        _CONFIG1(FWDTEN_OFF & ICS_PGx2 & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
        _CONFIG2(POSCMOD_HS & IOL1WAY_ON & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
    #elif defined(__PIC24FJ64GB004__)
        _CONFIG1(WDTPS_PS1 & FWPSA_PR32 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
        _CONFIG2(POSCMOD_HS & I2C1SEL_PRI & IOL1WAY_OFF & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
        _CONFIG3(WPFP_WPFP0 & SOSCSEL_SOSC & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM)
        _CONFIG4(DSWDTPS_DSWDTPS3 & DSWDTOSC_LPRC & RTCOSC_SOSC & DSBOREN_OFF & DSWDTEN_OFF)
    #elif defined(__32MX460F512L__) || defined(__32MX795F512L__)
        #pragma config UPLLEN   = ON        // USB PLL Enabled
        #pragma config FPLLMUL  = MUL_15        // PLL Multiplier
        #pragma config UPLLIDIV = DIV_2         // USB PLL Input Divider
        #pragma config FPLLIDIV = DIV_2         // PLL Input Divider
        #pragma config FPLLODIV = DIV_1         // PLL Output Divider
        #pragma config FPBDIV   = DIV_1         // Peripheral Clock divisor
        #pragma config FWDTEN   = OFF           // Watchdog Timer
        #pragma config WDTPS    = PS1           // Watchdog Timer Postscale
        #pragma config FCKSM    = CSDCMD        // Clock Switching & Fail Safe Clock Monitor
        #pragma config OSCIOFNC = OFF           // CLKO Enable
        #pragma config POSCMOD  = HS            // Primary Oscillator
        #pragma config IESO     = OFF           // Internal/External Switch-over
        #pragma config FSOSCEN  = OFF           // Secondary Oscillator Enable (KLO was off)
        #pragma config FNOSC    = PRIPLL        // Oscillator Selection
        #pragma config CP       = OFF           // Code Protect
        #pragma config BWP      = OFF           // Boot Flash Write Protect
        #pragma config PWP      = OFF           // Program Flash Write Protect
        #pragma config ICESEL   = ICS_PGx2      // ICE/ICD Comm Channel Select
   #elif defined(__dsPIC33EP512MU810__) || defined (__PIC24EP512GU810__)
        _FOSCSEL(FNOSC_FRC);
        _FOSC(FCKSM_CSECMD & OSCIOFNC_OFF & POSCMD_XT);
        _FWDT(FWDTEN_OFF);
    #else
        #error No hardware board defined, see "HardwareProfile.h" and __FILE__
    #endif
#elif defined(PIC24FJ256DA210_DEV_BOARD)
    _CONFIG1(FWDTEN_OFF & ICS_PGx2 & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
    _CONFIG2(POSCMOD_HS & IOL1WAY_ON & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
#elif defined(PIC24FJ64GB502_MICROSTICK)
    _CONFIG1(WDTPS_PS1 & FWPSA_PR32 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
    _CONFIG2(I2C1SEL_PRI & IOL1WAY_OFF & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
    _CONFIG3(WPFP_WPFP0 & SOSCSEL_SOSC & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM)
    _CONFIG4(DSWDTPS_DSWDTPS3 & DSWDTOSC_LPRC & RTCOSC_SOSC & DSBOREN_OFF & DSWDTEN_OFF)
#else
    #error No hardware board defined, see "HardwareProfile.h" and __FILE__
#endif

/** I N C L U D E S **********************************************************/

#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
#include "USB/usb_device.h"
#include "USB/usb.h"

#include "HardwareProfile.h"

/** V A R I A B L E S ********************************************************/
#if defined(__18CXX)
#pragma udata
#endif
char USB_Out_Buffer[CDC_DATA_OUT_EP_SIZE];
char RS232_Out_Data[CDC_DATA_IN_EP_SIZE];

unsigned char  NextUSBOut;
unsigned char    NextUSBOut;
//char RS232_In_Data;
unsigned char    LastRS232Out;  // Number of characters in the buffer
unsigned char    RS232cp;       // current position within the buffer
unsigned char RS232_Out_Data_Rdy = 0;
USB_HANDLE  lastTransmission;

//BOOL stringPrinted;


/** P R I V A T E  P R O T O T Y P E S ***************************************/
static void InitializeSystem(void);
void ProcessIO(void);
void USBDeviceTasks(void);
void YourHighPriorityISRCode();
void YourLowPriorityISRCode();
void USBCBSendResume(void);
void BlinkUSBStatus(void);
void UserInit(void);
void InitializeUSART(void);
void putcUSART(char c);
unsigned char getcUSART ();
int RemoconOutData(void);
unsigned char ToDec (const char s[]);

/** D E C L A R A T I O N S ***************************************************/
/* Timer0 0.1ms */
/* 100us / ( 0.021us x 4 ) = 1200  48MHz = 1/48us = 0.021us */
/* 1200 / 8 = 150    vXP[=8*/
/* 0x10000 - 0x96 = 0xFF88    16bitJE^*/
#define WRITE_TIMER0_COUNT        0xFF6A        //Timer0̎ 

//38kHz=26us
// 38kHz = ( 78 + 1 ) * 4 * 0.0208us(48MHz) * 4(vXP[) = 26.2912us
#define PWM_PERIOD	0x4E 	/* Period 78 = 0x4E */
#define	PWM_OFF		0
#define PWM_50		0x9E	/* PWM Duty 50% = (Period + 1) * 4 * 0.5 */
#define PWM_100		0x13C	/* PWM Duty 100% = (Period + 1) * 4 * 1.0 */

//33kHz=30us
// 33kHz = ( 89 + 1 ) * 4 * 0.0208us(48MHz) * 4(vXP[) = 29.952us
#define PWM_PERIOD_33k	0x59 	/* Period 89 = 0x59 */
#define	PWM_OFF_33k		0
#define PWM_50_33k		0xB4	/* PWM Duty 50% = (Period + 1) * 4 * 0.5 */
#define PWM_100_33k		0x168	/* PWM Duty 100% = (Period + 1) * 4 * 1.0 */

//40kHz=25us
// 40kHz = ( 74 + 1 ) * 4 * 0.0208us(48MHz) * 4(vXP[) = 25.000us
#define PWM_PERIOD_40k	0x4A 	/* Period 74 = 0x4A */
#define	PWM_OFF_40k		0
#define PWM_50_40k		0x96	/* PWM Duty 50% = (Period + 1) * 4 * 0.5 */
#define PWM_100_40k		0x12C	/* PWM Duty 100% = (Period + 1) * 4 * 1.0 */



// ԊORp
#define OUTSTATUS_OUTPUT_WAIT			0x00	/* o͏ԁ@o͑҂ */
#define OUTSTATUS_READER_CODE			0x01	/* o͏ԁ@[_R[h */
#define OUTSTATUS_DATA_CODE				0x02	/* o͏ԁ@f[^R[h */
#define OUTSTATUS_END					0x04	/* o͏ԁ@I */
#define OUTSTATUS_2ND_READER_CODE		0x08	/* o͏ԁ@2nd[_R[h */
#define OUTSTATUS_2ND_DATA_CODE			0x10	/* o͏ԁ@2ndf[^R[h */
#define OUTBUFFER_READER_SIZE			1		/* o̓obt@TCY@[_R[h(1byte) */
#define OUTBUFFER_DATA_SIZE				6		/* o̓obt@TCY@f[^(6byte) */
#define OUTBUFFER_SIZE					OUTBUFFER_READER_SIZE+OUTBUFFER_DATA_SIZE	/* o̓obt@TCY@[_R[h(1byte) + f[^(6byte) */
#define OUTBUFFER_FORMAT_SIZE_EX		1		/* g o̓obt@TCY@tH[}bgR[h(1byte) */
#define OUTBUFFER_DATA_SIZE_EX			2		/* g o̓obt@TCY@f[^TCYiPbitj(1byte) */
//#define OUTBUFFER_DATA_AREA_SIZE_EX		32		/* g o̓obt@TCY@f[^GATCY(32byte) */
//#define OUTBUFFER_DATA_AREA_SIZE_EX		33		/* g o̓obt@TCY@f[^GATCY(32byte)@33oCgƓdtH[}bg̓GARɑΉꍇ */
#define OUTBUFFER_DATA_AREA_SIZE_EX		36		/* g o̓obt@TCY@f[^GATCY(32byte)@36oCgƓdtH[}bg̎OHGARɑΉꍇ(ver2.1.5ł͑Õf[^JԂ@̗pđΉ) */
#define OUTBUFFER_SIZE_EX				OUTBUFFER_FORMAT_SIZE_EX+OUTBUFFER_DATA_SIZE_EX+OUTBUFFER_DATA_AREA_SIZE_EX	/* g o̓obt@TCY@[_R[h(1byte) + f[^(32byte) */
#define FORMATCODE_UNKNOWN				0		/* ԊOʐMtH[}bg s */
#define FORMATCODE_KADEN				1		/* ԊOʐMtH[}bg Ɠd */
#define FORMATCODE_NEC					2		/* ԊOʐMtH[}bg NEC */
#define FORMATCODE_SONY					3		/* ԊOʐMtH[}bg SONY */
#define FORMATCODE_MITSU				4		/* ԊOʐMtH[}bg MITSUBISHI */
#define FORMATCODE_DAIKIN				5		/* ԊOʐMtH[}bg DAIKIN */
#define FORMATCODE_DAIKIN2				6		/* ԊOʐMtH[}bg DAIKIN2 */
#define FORMATCODE_TMY					7		/* ԊOʐMtH[}bg TMY */
#define FORMATCODE_LUCKY				8		/* ԊOʐMtH[}bg ۑPd@ */
#define FORMATCODE_HITACHI				9		/* ԊOʐMtH[}bg (Om) */
#define FORMATCODE_TOSHIBA				10		/* ԊOʐMtH[}bg (GAR) */
#define FORMATCODE_HITACH_AC			11		/* ԊOʐMtH[}bg (GAR)@ƓdtH[}bg33oCgȂ̂œʂȃR[h */
#define FORMATCODE_TOSHIB_WXF			13		/* ԊOʐMtH[}bg ŃGARWX-F01E */
#define RECEIVE_WAIT_MODE_NONE			0		/* PCԊOR[hM҂[h@NONE */
#define RECEIVE_WAIT_MODE_WAIT			1		/* PCԊOR[hM҂[h@WAIT */

#define READTIMING						100		/* ǂݍݎ[usec] */
//#define READCODE_END_CNT				200 	/* ̉OFFI 1000 = 100[ms] / 0.1[ms] */
//#define READCODE_END_CNT				120 	/* ̉OFFI 1000 = 100[ms] / 0.1[ms] */
#define READCODE_END_CNT				150 	/* ̉OFFI 1000 = 100[ms] / 0.1[ms] */
#define SENDCODE_END_CNT				200 	/* IR[h̉OFF𑱂 1000 = 100[ms] / 0.1[ms] */
#define NEXT_DATA_WAIT					500		/* ̃f[^̓ǂݍ݂̎OFFpJn 2000 = 200[ms] / 0.1[ms] */
#define DATA_CODE_INTERVAL_MIN_CNT		40 		/* f[^Qɂ킩ĂR[h̃f[^ԍŏԊu 40 = 4[ms] / 0.1[ms] */
//#define DATA_CODE_INTERVAL_MAX_CNT		500 	/* f[^Qɂ킩ĂR[h̃f[^ԍőԊu 500 = 50[ms] / 0.1[ms] */
#define DATA_CODE_INTERVAL_MAX_CNT		READCODE_END_CNT	/* f[^Qɂ킩ĂR[h̃f[^ԍőԊu 500 = 50[ms] / 0.1[ms] */
//#define DATA_CODE_INTERVAL_SEND_CNT		260 	/* f[^Qɂ킩ĂR[h̑Mf[^Ԋu 300 = 30[ms] / 0.1[ms] */
#define DATA_CODE_INTERVAL_SEND_CNT		135 	/* f[^Qɂ킩ĂR[h̑Mf[^Ԋu 300 = 30[ms] / 0.1[ms] */
#define DATA_CODE_INTERVAL_SEND_CNT_SONY	260 	/* f[^Qɂ킩ĂR[h̑Mf[^Ԋu 300 = 30[ms] / 0.1[ms] */
#define DATA_CODE_INTERVAL_SEND_CNT_TOSHIB_WXF	69 	/* f[^Qɂ킩ĂR[h̑Mf[^Ԋu 300 = 30[ms] / 0.1[ms] */
//#define DATA_MAX_BITS					0xFF	/* f[^R[h̍őrbg */
//#define DATA_MAX_BITS					264		/* f[^R[h̍őrbg@33oCgƓdtH[}bg̓GARɑΉꍇ */
#define DATA_MAX_BITS					288		/* f[^R[h̍őrbg@36oCgƓdtH[}bg̎OHGARɑΉꍇ(ver2.1.5ł͑Õf[^JԂ@̗pđΉ) */

/* Ɠd */
//#define READERCODE_ON_KADEN			32		/* [_R[h ON 3.2ms / 0.1ms */ //
#define READERCODE_ON_KADEN			30		/* [_R[h ON 3.2ms / 0.116ms */
//#define READERCODE_OFF_KADEN		16		/* [_R[h OFF 1.6ms / 0.1ms */ //
#define READERCODE_OFF_KADEN		15		/* [_R[h OFF 1.6ms / 0.116ms */
//#define READERCODE_ON_T_KADEN		2		/* [_R[h ON 2T */
#define READERCODE_ON_T_KADEN		2		/* [_R[h ON/OFF=2 */
#define READERCODE_ON_MIN_KADEN		24		/* [_R[h ONԍŏ 24 = MIN40 / 12T * 8T */
#define READERCODE_OFF_MIN_KADEN	12		/* [_R[h OFFԍŏ 12 = MIN40 / 12T * 4T */
//#define READERCODE_OFF_KADEN		1600	/* [_R[h OFF [usec] */
#define READERCODE_MIN_KADEN		40		/* [_R[h ((3.2 + 1.6) - 0.8) / 0.1 [msec] */
#define READERCODE_MAX_KADEN		56		/* [_R[h ((3.2 + 1.6) + 0.8) / 0.1 [msec] */
//#define DATACODE_DATA1_KADEN		8		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_DATA1_KADEN		9		/* f[^R[h0/1f OFF̒ȏȂ1 (Ver2.1.5ɂɐݒ)*/
#define DATACODE_MIN_KADEN			4		/* f[^R[hŏ data0 ((0.4 + 0.4) - 0.4) / 0.1 [msec] */
#define DATACODE_MAX_KADEN			20		/* f[^R[hő data1 ((0.4 + 1.2) + 0.4) / 0.1 [msec] */
#define DATA0_ON_KADEN				4		/* f[^O ON 0.4ms / 0.1ms */
#define DATA0_OFF_KADEN				4		/* f[^O OFF 0.4ms / 0.1ms */
#define DATA1_ON_KADEN				4		/* f[^P ON 0.4ms / 0.1ms */
#define DATA1_OFF_KADEN				12		/* f[^P OFF 1.2ms / 0.1ms */
/* TMY(ƓdtH[}bg) */
#define DATACODE_DATA1_TMY			5
#define DATA1_OFF_TMY				8		/* f[^P OFF 0.8ms / 0.116ms */
/* ۑPd@ */
#define READERCODE_ON_LUCKY			41		/* [_R[h ON 4.8ms / 0.116ms */
#define READERCODE_OFF_LUCKY		22		/* [_R[h OFF 2.5ms / 0.116ms */
#define READERCODE_ON_T_LUCKY		2		/* [_R[h ON/OFF=2 */
#define READERCODE_ON_MIN_LUCKY		38		/* [_R[h ONԍŏ */
#define READERCODE_OFF_MIN_LUCKY	19		/* [_R[h OFFԍŏ */
#define READERCODE_MIN_LUCKY		57		/* [_R[h */
#define READERCODE_MAX_LUCKY		69		/* [_R[h */
#define DATACODE_DATA1_LUCKY		10		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_LUCKY			8		/* f[^R[hŏ data0 ((0.6 + 0.9) - 0.6) / 0.1 [msec] */
#define DATACODE_MAX_LUCKY			26		/* f[^R[hő data1 ((0.6 + 1.9) + 0.6) / 0.1 [msec] */
#define DATA0_ON_LUCKY				5		/* f[^O ON 0.6ms / 0.116ms */
#define DATA0_OFF_LUCKY				8		/* f[^O OFF 0.9ms / 0.116ms */
#define DATA1_ON_LUCKY				5		/* f[^P ON 0.6ms / 0.116ms */
#define DATA1_OFF_LUCKY				16		/* f[^P OFF 1.9ms / 0.116ms */
/* NEC */
#define READERCODE_ON_NEC			90		/* [_R[h ON 9.0ms / 0.1ms */
#define READERCODE_OFF_NEC			45		/* [_R[h OFF 4.5ms / 0.1ms */
//#define READERCODE_ON_T_NEC			2		/* [_R[h ON 2T */
#define READERCODE_ON_T_NEC			2		/* [_R[h ON/OFF=2 */
#define READERCODE_ON_MIN_NEC		80		/* [_R[h ONԍŏ 80 = MIN125 / 24T * 16T */
#define READERCODE_OFF_MIN_NEC		40		/* [_R[h OFFԍŏ 40 = MIN125 / 24T * 8T */
//#define READERCODE_OFF_NEC			4500	/* [_R[h OFF [usec] */
#define READERCODE_MIN_NEC			90		/* [_R[h ((9.0 + 4.5) - 4.5) / 0.1 [msec] */
#define READERCODE_MAX_NEC			180		/* [_R[h ((9.0 + 4.5) + 4.5) / 0.1 [msec] */
#define DATACODE_DATA1_NEC			12		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_NEC			5		/* f[^R[hŏ data0 ((0.56 + 0.56) - 0.56) / 0.1 [msec] */
//#define DATACODE_MAX_NEC			28		/* f[^R[hő data1 ((0.56 + 1.68) + 0.56) / 0.1 [msec] */
#define DATACODE_MAX_NEC			30		/* f[^R[hő data1 ((0.56 + 1.68) + 0.56) / 0.1 [msec] OmΉ */
#define DATA0_ON_NEC				5		/* f[^O ON 0.56ms / 0.1ms */
#define DATA0_OFF_NEC				5		/* f[^O OFF 0.56ms / 0.1ms */
#define DATA1_ON_NEC				5		/* f[^P ON 0.56ms / 0.1ms */
#define DATA1_OFF_NEC				16		/* f[^P OFF 1.68ms / 0.1ms */
/* (Om) */
#define READERCODE_ON_HITACHI		73		/* [_R[h ON 4.8ms / 0.116ms */
#define READERCODE_OFF_HITACHI		36		/* [_R[h OFF 2.5ms / 0.116ms */
#define READERCODE_ON_T_HITACHI		3		/* [_R[h ON/OFF=2 */
#define READERCODE_ON_MIN_HITACHI	70		/* [_R[h ONԍŏ */
#define READERCODE_OFF_MIN_HITACHI	33		/* [_R[h OFFԍŏ */
#define READERCODE_MIN_HITACHI		105		/* [_R[h */
#define READERCODE_MAX_HITACHI		113		/* [_R[h */
/* (GAR) */
#define READERCODE_ON_TOSHIBA		75		/* [_R[h ON 8.8ms / 0.116ms */
#define READERCODE_OFF_TOSHIBA		75		/* [_R[h OFF 8.8ms / 0.116ms */
#define READERCODE_ON_MIN_TOSHIBA	71		/* [_R[h ONԍŏ */
#define READERCODE_OFF_MIN_TOSHIBA	71		/* [_R[h OFFԍŏ */
#define READERCODE_MIN_TOSHIBA		140		/* [_R[h ŏ */
#define READERCODE_MAX_TOSHIBA		160		/* [_R[h ő */
#define DATACODE_DATA1_TOSHIBA		18		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_TOSHIBA		15		/* f[^R[hŏ data0 ((1.0 + 1.0) - ) / 0.116 [msec] */
#define DATACODE_MAX_TOSHIBA		40		/* f[^R[hő data1 ((1.0 + 3.2) + ) / 0.116 [msec] */
#define DATA0_ON_TOSHIBA			9		/* f[^O ON 0.4ms / 0.1ms */
#define DATA0_OFF_TOSHIBA			9		/* f[^O OFF 0.5ms / 0.1ms */
#define DATA1_ON_TOSHIBA			9		/* f[^P ON 0.4ms / 0.1ms */
#define DATA1_OFF_TOSHIBA			28		/* f[^P OFF 1.3ms / 0.1ms */
/* ŃGARWX-F01E  */
#define READERCODE_ON_TOSHIB_WXF	38		/* [_R[h ON 4.4ms / 0.116ms */
#define READERCODE_OFF_TOSHIB_WXF	38		/* [_R[h OFF 4.4ms / 0.116ms */
#define READERCODE_ON_MIN_TOSHIB_WXF	34		/* [_R[h ONԍŏ */
#define READERCODE_OFF_MIN_TOSHIB_WXF	34		/* [_R[h OFFԍŏ */
#define READERCODE_MIN_TOSHIB_WXF	68		/* [_R[h ŏ */
#define READERCODE_MAX_TOSHIB_WXF	86		/* [_R[h ő */
#define DATACODE_DATA1_TOSHIB_WXF	9		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_TOSHIB_WXF		7		/* f[^R[hŏ data0 ((0.5 + 0.5) - ) / 0.116 [msec] */
#define DATACODE_MAX_TOSHIB_WXF		23		/* f[^R[hő data1 ((0.5 + 1.6) + ) / 0.116 [msec] */
#define DATA0_ON_TOSHIB_WXF			5		/* f[^O ON 0.5ms / 0.1ms */
#define DATA0_OFF_TOSHIB_WXF		5		/* f[^O OFF 0.5ms / 0.1ms */
#define DATA1_ON_TOSHIB_WXF			5		/* f[^P ON 0.5ms / 0.1ms */
#define DATA1_OFF_TOSHIB_WXF		14		/* f[^P OFF 1.6ms / 0.1ms */
/* SONY */
//#define READERCODE_ON_SONY			24		/* [_R[h ON 2.4ms / 0.1ms */
#define READERCODE_ON_SONY			21		/* [_R[h ON 2.4ms / 0.116ms */
//#define READERCODE_OFF_SONY			6		/* [_R[h OFF 0.6ms / 0.1ms */
#define READERCODE_OFF_SONY			5		/* [_R[h OFF 0.6ms / 0.1ms */
#define READERCODE_ON_T_SONY		4		/* [_R[h ON 4T */
#define READERCODE_ON_MIN_SONY		16		/* [_R[h ONԍŏ 16 = MIN24 / 5T * 4T */
#define READERCODE_OFF_MIN_SONY		4		/* [_R[h OFFԍŏ 4 = MIN24 / 5T * 1T */
//#define READERCODE_OFF_SONY			600		/* [_R[h OFF [usec] */
//#define READERCODE_MIN_SONY			24		/* [_R[h ((2.4 + 0.6) - 0.6) / 0.1 [msec] */
#define READERCODE_MIN_SONY			20		/* [_R[h ((2.4 + 0.6) - 0.6) / 0.116 /  [msec] */
//#define READERCODE_MAX_SONY			36		/* [_R[h ((2.4 + 0.6) + 0.6) / 0.1 [msec] */
#define READERCODE_MAX_SONY			30		/* [_R[h ((2.4 + 0.6) + 0.6) / 0.116 [msec] */
#define DATACODE_DATA1_SONY			9		/* f[^R[h0/1f ON̒ȏȂ1 */
#define DATACODE_MIN_SONY			6		/* f[^R[hŏ data0 ((0.6 + 0.6) - 0.6) / 0.1 [msec] */
#define DATACODE_MAX_SONY			24		/* f[^R[hő data1 ((1.2 + 0.6) + 0.6) / 0.1 [msec] */
//#define DATA0_ON_SONY				6		/* f[^O ON 0.6ms / 0.1ms */
#define DATA0_ON_SONY				5		/* f[^O ON 0.6ms / 0.116ms */
//#define DATA0_OFF_SONY				6		/* f[^O OFF 0.6ms / 0.1ms */
#define DATA0_OFF_SONY				5		/* f[^O OFF 0.6ms / 0.116ms */
//#define DATA1_ON_SONY				12		/* f[^P ON 1.2ms / 0.1ms */
#define DATA1_ON_SONY				10		/* f[^P ON 1.2ms / 0.116ms */
//#define DATA1_OFF_SONY				6		/* f[^P OFF 0.6ms / 0.1ms */
#define DATA1_OFF_SONY				5		/* f[^P OFF 0.6ms / 0.116ms */
/* MITSUBISHI [_R[hȂAȂf[^ */
#define DATACODE_DATA1_M			14		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_M				8		/* f[^R[hŏ data0 ((0.4 + 0.8) - 0.4) / 0.1 [msec] */
#define DATACODE_MAX_M				28		/* f[^R[hő data1 ((0.4 + 2.0) + 0.4) / 0.1 [msec] */
#define DATA0_ON_M					4		/* f[^O ON 0.4ms / 0.1ms */
#define DATA0_OFF_M					8		/* f[^O OFF 0.8ms / 0.1ms */
#define DATA1_ON_M					4		/* f[^P ON 0.4ms / 0.1ms */
#define DATA1_OFF_M					20		/* f[^P OFF 2.0ms / 0.1ms */
/* DAIKIN 1 */
#if 1
#define READERCODE_ON_DAI			44		/* [_R[h ON 4.4ms / 0.1ms */
#define READERCODE_OFF_DAI			22		/* [_R[h OFF 2.2ms / 0.1ms */
#define READERCODE_ON_T_DAI			2		/* [_R[h ON 2T */
#define READERCODE_ON_MIN_DAI		29		/* [_R[h ONԍŏ 29 = MIN44 / 15T * 10T */
#define READERCODE_OFF_MIN_DAI		14		/* [_R[h OFFԍŏ 14 = MIN44 / 15T * 5T */
//#define READERCODE_OFF_DAI		1600	/* [_R[h OFF [usec] */
#define READERCODE_MIN_DAI			44		/* [_R[h ((4.4 + 2.2) - 2.2) / 0.1 [msec] */
#define READERCODE_MAX_DAI			88		/* [_R[h ((4.4 + 2.2) + 2.2) / 0.1 [msec] */
#define DATACODE_DATA1_DAI			7		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_DAI			4		/* f[^R[hŏ data0 ((0.4 + 0.4) - 0.4) / 0.1 [msec] */
#define DATACODE_MAX_DAI			23		/* f[^R[hő data1 ((0.4 + 1.3) + 0.4) / 0.1 [msec] */
#define DATA0_ON_DAI				4		/* f[^O ON 0.4ms / 0.1ms */
#define DATA0_OFF_DAI				4		/* f[^O OFF 0.5ms / 0.1ms */
#define DATA1_ON_DAI				4		/* f[^P ON 0.4ms / 0.1ms */
#define DATA1_OFF_DAI				13		/* f[^P OFF 1.3ms / 0.1ms */
#endif
#if 0
#define READERCODE_ON_DAI			50		/* [_R[h ON 5.0ms / 0.1ms */
#define READERCODE_OFF_DAI			25		/* [_R[h OFF 2.5ms / 0.1ms */
#define READERCODE_ON_T_DAI			2		/* [_R[h ON 2T */
#define READERCODE_ON_MIN_DAI		33		/* [_R[h ONԍŏ 33 = MIN50 / 15T * 10T */
#define READERCODE_OFF_MIN_DAI		16		/* [_R[h OFFԍŏ 16 = MIN50 / 15T * 5T */
//#define READERCODE_OFF_DAI		1600	/* [_R[h OFF [usec] */
#define READERCODE_MIN_DAI			50		/* [_R[h ((5.0 + 2.5) - 2.5) / 0.1 [msec] */
#define READERCODE_MAX_DAI			100		/* [_R[h ((5.0 + 2.5) + 2.5) / 0.1 [msec] */
#define DATACODE_DATA1_DAI			7		/* f[^R[h0/1f OFF̒ȏȂ1 */
#define DATACODE_MIN_DAI			5		/* f[^R[hŏ data0 ((0.5 + 0.5) - 0.5) / 0.1 [msec] */
#define DATACODE_MAX_DAI			25		/* f[^R[hő data1 ((0.5 + 1.5) + 0.5) / 0.1 [msec] */
#define DATA0_ON_DAI				5		/* f[^O ON 0.5ms / 0.1ms */
#define DATA0_OFF_DAI				5		/* f[^O OFF 0.5ms / 0.1ms */
#define DATA1_ON_DAI				5		/* f[^P ON 0.5ms / 0.1ms */
#define DATA1_OFF_DAI				15		/* f[^P OFF 1.5ms / 0.1ms */
#endif
/* DAIKIN 2 */
#define READERCODE_ON_DAI2			30		/* [_R[h ON 3.0ms / 0.1ms */
#define READERCODE_OFF_DAI2			90		/* [_R[h OFF 9.0ms / 0.1ms */
#define READERCODE_OFF_T_DAI2		3		/* [_R[h OFF 3T */
#define READERCODE_ON_MIN_DAI2		22		/* [_R[h ONԍŏ 22 = MIN90 / 12T * 3T */
#define READERCODE_OFF_MIN_DAI2		67		/* [_R[h OFFԍŏ 67 = MIN90 / 12T * 9T */
//#define READERCODE_OFF_DAI		1600	/* [_R[h OFF [usec] */
#define READERCODE_MIN_DAI2			90		/* [_R[h ((3.0 + 9.0) - 3.0) / 0.1 [msec] */
#define READERCODE_MAX_DAI2			150		/* [_R[h ((3.0 + 9.0) + 3.0) / 0.1 [msec] */
// f[^DAIKIN1Ɠ
//#define DATACODE_DATA1_DAI2			7		/* f[^R[h0/1f OFF̒ȏȂ1 */
//#define DATACODE_MIN_DAI2			5		/* f[^R[hŏ data0 ((0.5 + 0.5) - 0.5) / 0.1 [msec] */
//#define DATACODE_MAX_DAI2			25		/* f[^R[hő data1 ((0.5 + 1.5) + 0.5) / 0.1 [msec] */
//#define DATA0_ON_DAI2				5		/* f[^O ON 0.5ms / 0.1ms */
//#define DATA0_OFF_DAI2				5		/* f[^O OFF 0.5ms / 0.1ms */
//#define DATA1_ON_DAI2				5		/* f[^P ON 0.5ms / 0.1ms */
//#define DATA1_OFF_DAI2				15		/* f[^P OFF 1.5ms / 0.1ms */

#define CDC_DATA_BUFFER_SIZE				80

/** V A R I A B L E S ********************************************************/
char	c_version[]="2.1.5";


// ԊORf[^Mpϐ
unsigned int ui_out_pos = 0;
unsigned char uc_out_status = OUTSTATUS_OUTPUT_WAIT;
unsigned char uc_out_buff[OUTBUFFER_SIZE_EX];
unsigned int ui_out_on_time = 0;
unsigned int ui_out_off_time = 0;
unsigned char uc_out_data_len = 0;
unsigned char uc_out_data0_on = 0;
unsigned char uc_out_data0_off = 0;
unsigned char uc_out_data1_on = 0;
unsigned char uc_out_data1_off = 0;
//unsigned char uc_send_bit_size = 0;
unsigned int ui_send_bit_size = 0;
unsigned char uc_send_bit_size_2nd_data = 0;


unsigned int ui_PWM50_Set_Val = PWM_50;

//unsigned char ReceivedDataBuffer[RX_BUFFER_SIZE];
unsigned char ReceivedDataBuffer[CDC_DATA_BUFFER_SIZE] = {0};			/* ǂݍݒ̃f[^ۑ */
unsigned char uc_tmp_buff[OUTBUFFER_SIZE_EX];
unsigned char uc_tmp_pos = 0;
unsigned char uc_tmp_status = OUTSTATUS_END;
unsigned char uc_receive_pos = 0;


/** VECTOR REMAPPING ***********************************************/
#if defined(__18CXX)
	//On PIC18 devices, addresses 0x00, 0x08, and 0x18 are used for
	//the reset, high priority interrupt, and low priority interrupt
	//vectors.  However, the Microchip HID bootloader occupies the
	//0x00-0xFFF program memory region.  Therefore, the bootloader code remaps 
	//these vectors to new locations as indicated below.  This remapping is 
	//only necessary if you wish to be able to (optionally) program the hex file 
	//generated from this project with the USB bootloader.  
	#define REMAPPED_RESET_VECTOR_ADDRESS			0x1000
	#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x1008
	#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x1018
	#define APP_VERSION_ADDRESS                     0x1016 //Fixed location, so the App FW image version can be read by the bootloader.
	#define APP_SIGNATURE_ADDRESS                   0x1006 //Signature location that must be kept at blaknk value (0xFFFF) in this project (has special purpose for bootloader).

    //--------------------------------------------------------------------------
    //Application firmware image version values, as reported to the bootloader
    //firmware.  These are useful so the bootloader can potentially know if the
    //user is trying to program an older firmware image onto a device that
    //has already been programmed with a with a newer firmware image.
    //Format is APP_FIRMWARE_VERSION_MAJOR.APP_FIRMWARE_VERSION_MINOR.
    //The valid minor version is from 00 to 99.  Example:
    //if APP_FIRMWARE_VERSION_MAJOR == 1, APP_FIRMWARE_VERSION_MINOR == 1,
    //then the version is "1.01"
    #define APP_FIRMWARE_VERSION_MAJOR  1   //valid values 0-255
    #define APP_FIRMWARE_VERSION_MINOR  0   //valid values 0-99
    //--------------------------------------------------------------------------
	
	#pragma romdata AppVersionAndSignatureSection = APP_VERSION_ADDRESS
	ROM unsigned char AppVersion[2] = {APP_FIRMWARE_VERSION_MINOR, APP_FIRMWARE_VERSION_MAJOR};
	#pragma romdata AppSignatureSection = APP_SIGNATURE_ADDRESS
	ROM unsigned short int SignaturePlaceholder = 0xFFFF;
	
	#pragma code HIGH_INTERRUPT_VECTOR = 0x08
	void High_ISR (void)
	{
	     _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Low_ISR (void)
	{
	     _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	extern void _startup (void);        // See c018i.c in your C18 compiler dir
	#pragma code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
	void _reset (void)
	{
	    _asm goto _startup _endasm
	}
	#pragma code REMAPPED_HIGH_INTERRUPT_VECTOR = REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
	void Remapped_High_ISR (void)
	{
	     _asm goto YourHighPriorityISRCode _endasm
	}
	#pragma code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
	void Remapped_Low_ISR (void)
	{
	     _asm goto YourLowPriorityISRCode _endasm
	}
	#pragma code
	
	
	//These are your actual interrupt handling routines.
	#pragma interrupt YourHighPriorityISRCode
	void YourHighPriorityISRCode()
	{
		//Check which interrupt flag caused the interrupt.
		//Service the interrupt
		//Clear the interrupt flag
		//Etc.
        #if defined(USB_INTERRUPT)
	        USBDeviceTasks();
        #endif
	
	}	//This return will be a "retfie fast", since this is in a #pragma interrupt section 
	#pragma interruptlow YourLowPriorityISRCode
	void YourLowPriorityISRCode()
	{
		//Check which interrupt flag caused the interrupt.
		//Service the interrupt
		//Clear the interrupt flag
		//Etc.
	
		int fi;
	
		if(INTCONbits.TMR0IF == 1)
		{
			INTCONbits.TMR0IF = 0;
			WriteTimer0(WRITE_TIMER0_COUNT);
			
			/* ԊOR̃f[^o */
			RemoconOutData();

			if (uc_tmp_status == OUTSTATUS_OUTPUT_WAIT)
			{
				for(fi = 0; fi < uc_tmp_pos; fi++){
					uc_out_buff[fi] = uc_tmp_buff[fi];
				}
				uc_tmp_status = OUTSTATUS_END;
			}
		}

	}	//This return will be a "retfie", since this is in a #pragma interruptlow section 

#elif defined(__C30__) || defined __XC16__
    #if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
        /*
         *	ISR JUMP TABLE
         *
         *	It is necessary to define jump table as a function because C30 will
         *	not store 24-bit wide values in program memory as variables.
         *
         *	This function should be stored at an address where the goto instructions 
         *	line up with the remapped vectors from the bootloader's linker script.
         *  
         *  For more information about how to remap the interrupt vectors,
         *  please refer to AN1157.  An example is provided below for the T2
         *  interrupt with a bootloader ending at address 0x1400
         */
//        void __attribute__ ((address(0x1404))) ISRTable(){
//        
//        	asm("reset"); //reset instruction to prevent runaway code
//        	asm("goto %0"::"i"(&_T2Interrupt));  //T2Interrupt's address
//        }
    #endif
#elif defined(_PIC14E)
    	//These are your actual interrupt handling routines.
	void interrupt ISRCode()
	{
		//Check which interrupt flag caused the interrupt.
		//Service the interrupt
		//Clear the interrupt flag
		//Etc.
        #if defined(USB_INTERRUPT)

	        USBDeviceTasks();
        #endif
	}
#endif



/** DECLARATIONS ***************************************************/
#pragma code

/******************************************************************************
 * Function:        void main(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Main program entry point.
 *
 * Note:            None
 *****************************************************************************/
#if defined(__18CXX)
void main(void)
#else
int main(void)
#endif
{   
    InitializeSystem();

    #if defined(USB_INTERRUPT)
        USBDeviceAttach();
    #endif

//	^C}0̐ݒ
	OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_8);
	WriteTimer0(WRITE_TIMER0_COUNT);
//	CCPW[PWMݒ
	OpenPWM1(PWM_PERIOD);
//	^C}2̐ݒ vXP[1:4
	OpenTimer2(TIMER_INT_OFF & T2_PS_1_4 & T2_POST_1_1 );
	SetDCPWM1(PWM_OFF);
//	SetDCPWM1(PWM_50);

//	荞݊Jn
	RCONbits.IPEN = 1;	//荞ݗDt
	INTCON2bits.TMR0IP = 0;	//^C}0ʃx荞݂ɐݒ
	INTCONbits.TMR0IE = 1;	//^C}0荞݋
	INTCONbits.GIEL = 1;	//ʃx荞݂̋
//	INTCONbits.GIEH = 1;	//ʃx荞݂̋
	INTCONbits.GIE = 1;
	
    while(1)
    {
        #if defined(USB_POLLING)
		// Check bus status and service USB interrupts.
        USBDeviceTasks(); // Interrupt or polling method.  If using polling, must call
        				  // this function periodically.  This function will take care
        				  // of processing and responding to SETUP transactions 
        				  // (such as during the enumeration process when you first
        				  // plug in).  USB hosts require that USB devices should accept
        				  // and process SETUP packets in a timely fashion.  Therefore,
        				  // when using polling, this function should be called 
        				  // regularly (such as once every 1.8ms or faster** [see 
        				  // inline code comments in usb_device.c for explanation when
        				  // "or faster" applies])  In most cases, the USBDeviceTasks() 
        				  // function does not take very long to execute (ex: <100 
        				  // instruction cycles) before it returns.
        #endif
    				  

		// Application-specific tasks.
		// Application related code may be added here, or in the ProcessIO() function.
        ProcessIO();        
    }//end while
}//end main


/********************************************************************
 * Function:        static void InitializeSystem(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        InitializeSystem is a centralize initialization
 *                  routine. All required USB initialization routines
 *                  are called from here.
 *
 *                  User application initialization routine should
 *                  also be called from here.                  
 *
 * Note:            None
 *******************************************************************/
static void InitializeSystem(void)
{
    ADCON1 |= 0x0F;                 // Default all pins to digital

//	The USB specifications require that USB peripheral devices must never source
//	current onto the Vbus pin.  Additionally, USB peripherals should not source
//	current on D+ or D- when the host/hub is not actively powering the Vbus line.
//	When designing a self powered (as opposed to bus powered) USB peripheral
//	device, the firmware should make sure not to turn on the USB module and D+
//	or D- pull up resistor unless Vbus is actively powered.  Therefore, the
//	firmware needs some means to detect when Vbus is being powered by the host.
//	A 5V tolerant I/O pin can be connected to Vbus (through a resistor), and
// 	can be used to detect when Vbus is high (host actively powering), or low
//	(host is shut down or otherwise not supplying power).  The USB firmware
// 	can then periodically poll this I/O pin to know when it is okay to turn on
//	the USB module/D+/D- pull up resistor.  When designing a purely bus powered
//	peripheral device, it is not possible to source current on D+ or D- when the
//	host is not actively providing power on Vbus. Therefore, implementing this
//	bus sense feature is optional.  This firmware can be made to use this bus
//	sense feature by making sure "USE_USB_BUS_SENSE_IO" has been defined in the
//	HardwareProfile.h file.    
    #if defined(USE_USB_BUS_SENSE_IO)
    tris_usb_bus_sense = INPUT_PIN; // See HardwareProfile.h
    #endif
    
//	If the host PC sends a GetStatus (device) request, the firmware must respond
//	and let the host know if the USB peripheral device is currently bus powered
//	or self powered.  See chapter 9 in the official USB specifications for details
//	regarding this request.  If the peripheral device is capable of being both
//	self and bus powered, it should not return a hard coded value for this request.
//	Instead, firmware should check if it is currently self or bus powered, and
//	respond accordingly.  If the hardware has been configured like demonstrated
//	on the PICDEM FS USB Demo Board, an I/O pin can be polled to determine the
//	currently selected power source.  On the PICDEM FS USB Demo Board, "RA2" 
//	is used for	this purpose.  If using this feature, make sure "USE_SELF_POWER_SENSE_IO"
//	has been defined in HardwareProfile - (platform).h, and that an appropriate I/O pin 
//  has been mapped	to it.
    #if defined(USE_SELF_POWER_SENSE_IO)
    tris_self_power = INPUT_PIN;	// See HardwareProfile.h
    #endif
    
    UserInit();

    USBDeviceInit();	//usb_device.c.  Initializes USB module SFRs and firmware
    					//variables to known states.
}//end InitializeSystem



/******************************************************************************
 * Function:        void UserInit(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This routine should take care of all of the demo code
 *                  initialization that is required.
 *
 * Note:            
 *
 *****************************************************************************/
void UserInit(void)
{
	unsigned char i;

	int fi;

/*	TRISB = 0x00;	//RB5 b7:RB7 b6:RB6 b5:RB5 b4:RB4*/
	TRISB = 0x30;	//RB5,RB4
/*	TRISC = 0x80;	//RCo  b7:RC7 b6:RC6 b5:RC5 b4:RC4 b3:RC3 b2:RC2 b1:RC1 bit0:RC0*/
	TRISC = 0x01;	//RC0

	LATC = 0xff;
	LATCbits.LATC2 = 0;

//	ANSEL = 0x00;
//	ANSELH = 0x00;	//SăfW^

//	INTCON2bits.RABPU = 0;	//vAbvg悤ɂ
//	WPUBbits.WPUB4 = 1;
//	WPUBbits.WPUB5 = 1;
//	WPUBbits.WPUB6 = 1;
//	WPUBbits.WPUB7 = 1;

    //initialize the variable holding the handle for the last
	
    for(fi = 0; fi < OUTBUFFER_SIZE_EX; fi++ )
    {
	    uc_out_buff[fi] = 0;
	}

    InitializeUSART();

// 	 Initialize the arrays
	for (i=0; i<sizeof(USB_Out_Buffer); i++)
    {
		USB_Out_Buffer[i] = 0;
    }

	mInitAllLEDs();

    //Initialize I/O pin and ADC settings to collect potentiometer measurements
    mInitPOT();


	NextUSBOut = 0;
	LastRS232Out = 0;
	lastTransmission = 0;

//////////	mInitAllLEDs();
}//end UserInit

/******************************************************************************
 * Function:        void InitializeUSART(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This routine initializes the UART to 19200
 *
 * Note:            
 *
 *****************************************************************************/
void InitializeUSART(void)
{
	    unsigned char c;
        #if defined(__18F14K50)
    	    //ANSELHbits.ANS11 = 0;	// Make RB5 digital so USART can use pin for Rx
            ANSELH = 0;
            #ifndef BAUDCON
                #define BAUDCON BAUDCTL
            #endif
        #endif

        UART_TRISRx=1;				// RX
        UART_TRISTx=0;				// TX
        TXSTA = 0x24;       	// TX enable BRGH=1
        RCSTA = 0x90;       	// Single Character RX
        SPBRG = 0x71;
        SPBRGH = 0x02;      	// 0x0271 for 48MHz -> 19200 baud
        BAUDCON = 0x08;     	// BRG16 = 1
        c = RCREG;				// read 

}//end InitializeUSART

#define mDataRdyUSART() PIR1bits.RCIF
#define mTxRdyUSART()   TXSTAbits.TRMT

/******************************************************************************
 * Function:        void putcUSART(char c)
 *
 * PreCondition:    None
 *
 * Input:           char c - character to print to the UART
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Print the input character to the UART
 *
 * Note:            
 *
 *****************************************************************************/
void putcUSART(char c)  
{
	TXREG = c;
}


/******************************************************************************
 * Function:        void mySetLineCodingHandler(void)
 *
 * PreCondition:    USB_CDC_SET_LINE_CODING_HANDLER is defined
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function gets called when a SetLineCoding command
 *                  is sent on the bus.  This function will evaluate the request
 *                  and determine if the application should update the baudrate
 *                  or not.
 *
 * Note:            
 *
 *****************************************************************************/
#if defined(USB_CDC_SET_LINE_CODING_HANDLER)
void mySetLineCodingHandler(void)
{
    //If the request is not in a valid range
    if(cdc_notice.GetLineCoding.dwDTERate.Val > 115200)
    {
        //NOTE: There are two ways that an unsupported baud rate could be
        //handled.  The first is just to ignore the request and don't change
        //the values.  That is what is currently implemented in this function.
        //The second possible method is to stall the STATUS stage of the request.
        //STALLing the STATUS stage will cause an exception to be thrown in the 
        //requesting application.  Some programs, like HyperTerminal, handle the
        //exception properly and give a pop-up box indicating that the request
        //settings are not valid.  Any application that does not handle the
        //exception correctly will likely crash when this requiest fails.  For
        //the sake of example the code required to STALL the status stage of the
        //request is provided below.  It has been left out so that this demo
        //does not cause applications without the required exception handling
        //to crash.
        //---------------------------------------
        //USBStallEndpoint(0,1);
    }
    else
    {
        //Update the baudrate info in the CDC driver
        CDCSetBaudRate(cdc_notice.GetLineCoding.dwDTERate.Val);
        
        //Update the baudrate of the UART
        {
            DWORD_VAL dwBaud;
            dwBaud.Val = (DWORD)(GetSystemClock()/4)/line_coding.dwDTERate.Val-1;
            SPBRG = dwBaud.v[0];
            SPBRGH = dwBaud.v[1];
        }    
    }
}
#endif

/******************************************************************************
 * Function:        void putcUSART(char c)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          unsigned char c - character to received on the UART
 *
 * Side Effects:    None
 *
 * Overview:        Print the input character to the UART
 *
 * Note:            
 *
 *****************************************************************************/
unsigned char getcUSART ()
{
	char  c;

	if (RCSTAbits.OERR)  // in case of overrun error
	{                    // we should never see an overrun error, but if we do, 
		RCSTAbits.CREN = 0;  // reset the port
		c = RCREG;
		RCSTAbits.CREN = 1;  // and keep going.
	}
	else
    {
		c = RCREG;
    }
// not necessary.  EUSART auto clears the flag when RCREG is cleared
//	PIR1bits.RCIF = 0;    // clear Flag

	return c;
}

/********************************************************************
 * Function:        void ProcessIO(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is a place holder for other user
 *                  routines. It is a mixture of both USB and
 *                  non-USB tasks.
 *
 * Note:            None
 *******************************************************************/
void ProcessIO(void)
{   
    char Buff[3]="00";
    char Message[4];
    char Strcrlf[3]="\r\n";
	int fi = 0;

    //Blink the LEDs according to the USB device status
    BlinkUSBStatus();
    // User Application USB tasks
    if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;

	if (RS232_Out_Data_Rdy == 0)  // only check for new USB buffer if the old RS232 buffer is
	{						  // empty.  This will cause additional USB packets to be NAK'd
		LastRS232Out = getsUSBUSART(RS232_Out_Data,64); //until the buffer is free.
		if(LastRS232Out > 0)
		{	
			RS232_Out_Data_Rdy = 1;  // signal buffer full
			RS232cp = 0;  // Reset the current position
		}
	}

    //Check if one or more bytes are waiting in the physical UART transmit
    //queue.  If so, send it out the UART TX pin.
	if(RS232_Out_Data_Rdy && mTxRdyUSART())
	{


    	#if defined(USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL)
        	//Make sure the receiving UART device is ready to receive data before 
        	//actually sending it.
        	if(UART_CTS == USB_CDC_CTS_ACTIVE_LEVEL)
        	{
        		putcUSART(RS232_Out_Data[RS232cp]);
        		++RS232cp;
        		if (RS232cp == LastRS232Out)
        			RS232_Out_Data_Rdy = 0;
    	    }
	    #else
	        //Hardware flow control not being used.  Just send the data.
			ReceivedDataBuffer[uc_receive_pos] = RS232_Out_Data[RS232cp];
			++uc_receive_pos;

			if( ReceivedDataBuffer[uc_receive_pos - 1] == 0x0A)
			{

				if(uc_receive_pos > 2)
				{
					uc_tmp_pos = uc_receive_pos >> 1;

//						putsUSART(Strcrlf);
					for(fi = 0; fi < uc_tmp_pos; fi++){
						Buff[0] = ReceivedDataBuffer[fi*2];
						Buff[1] = ReceivedDataBuffer[fi*2+1];
						uc_tmp_buff[fi] = ToDec(Buff);

//		        			putsUSART(itoa(uc_tmp_buff[fi], Message));
//							putsUSART(Strcrlf);
					}
//						putsUSART(Strcrlf);
				}
				else
				{
					// echoŏo͂ftHg̖
					// D݂̖߂ݒ肷
					// TMYTS-RKT01Z̕\
					uc_tmp_buff[0] = 0x07;
					uc_tmp_buff[1] = 0x20;
					uc_tmp_buff[2] = 0x00;
					uc_tmp_buff[3] = 0x33;
					uc_tmp_buff[4] = 0x00;
					uc_tmp_buff[5] = 0x30;
					uc_tmp_buff[6] = 0x2B;
					uc_tmp_pos = 7;	// = 6 + 1
				}

				for( fi = 0 ; fi < CDC_DATA_BUFFER_SIZE ; fi++ ){
					ReceivedDataBuffer[fi] = 0;
				}
				uc_receive_pos = 0;

				uc_tmp_status = OUTSTATUS_OUTPUT_WAIT;
			}
			else
			{
				if(uc_receive_pos == CDC_DATA_BUFFER_SIZE)
				{
					for( fi = 0 ; fi < CDC_DATA_BUFFER_SIZE ; fi++ ){
						ReceivedDataBuffer[fi] = 0;
					}
					uc_receive_pos = 0;
				}
			}

    		putcUSART(RS232_Out_Data[RS232cp]);
    		++RS232cp;
    		if (RS232cp == LastRS232Out)
    			RS232_Out_Data_Rdy = 0;	    
	    #endif
	}

    //Check if we received a character over the physical UART, and we need
    //to buffer it up for eventual transmission to the USB host.
	if(mDataRdyUSART() && (NextUSBOut < (CDC_DATA_OUT_EP_SIZE - 1)))
	{
		USB_Out_Buffer[NextUSBOut] = getcUSART();
		++NextUSBOut;
		USB_Out_Buffer[NextUSBOut] = 0;
	}
	
	#if defined(USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL)
    	//Drive RTS pin, to let UART device attached know if it is allowed to 
    	//send more data or not.  If the receive buffer is almost full, we 
    	//deassert RTS.
    	if(NextUSBOut <= (CDC_DATA_OUT_EP_SIZE - 5u))
    	{
            UART_RTS = USB_CDC_RTS_ACTIVE_LEVEL;
        }   	
        else
        {
        	UART_RTS = (USB_CDC_RTS_ACTIVE_LEVEL ^ 1);
        }    
    #endif	

    //Check if any bytes are waiting in the queue to send to the USB host.
    //If any bytes are waiting, and the endpoint is available, prepare to
    //send the USB packet to the host.
	if((USBUSARTIsTxTrfReady()) && (NextUSBOut > 0))
	{
		putUSBUSART(&USB_Out_Buffer[0], NextUSBOut);
		NextUSBOut = 0;
	}

    CDCTxService();

}//end ProcessIO

/********************************************************************
 * Function:        void BlinkUSBStatus(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        BlinkUSBStatus turns on and off LEDs 
 *                  corresponding to the USB device state.
 *
 * Note:            mLED macros can be found in HardwareProfile.h
 *                  USBDeviceState is declared and updated in
 *                  usb_device.c.
 *******************************************************************/
void BlinkUSBStatus(void)
{
    static WORD led_count=0;
    
    if(led_count == 0)led_count = 10000U;
    led_count--;

    #define mLED_Both_Off()         {mLED_1_Off();mLED_2_Off();}
    #define mLED_Both_On()          {mLED_1_On();mLED_2_On();}
    #define mLED_Only_1_On()        {mLED_1_On();mLED_2_Off();}
    #define mLED_Only_2_On()        {mLED_1_Off();mLED_2_On();}

    if(USBSuspendControl == 1)
    {
        if(led_count==0)
        {
            mLED_1_Toggle();
            if(mGetLED_1())
            {
                mLED_2_On();
            }
            else
            {
                mLED_2_Off();
            }
        }//end if
    }
    else
    {
        if(USBDeviceState == DETACHED_STATE)
        {
            mLED_Both_Off();
        }
        else if(USBDeviceState == ATTACHED_STATE)
        {
            mLED_Both_On();
        }
        else if(USBDeviceState == POWERED_STATE)
        {
            mLED_Only_1_On();
        }
        else if(USBDeviceState == DEFAULT_STATE)
        {
            mLED_Only_2_On();
        }
        else if(USBDeviceState == ADDRESS_STATE)
        {
            if(led_count == 0)
            {
                mLED_1_Toggle();
                mLED_2_Off();
            }//end if
        }
        else if(USBDeviceState == CONFIGURED_STATE)
        {
            if(led_count==0)
            {
                mLED_1_Toggle();
                if(mGetLED_1())
                {
                    mLED_2_Off();
                }
                else
                {
                    mLED_2_On();
                }
            }//end if
        }//end if(...)
    }//end if(UCONbits.SUSPND...)

}//end BlinkUSBStatus


// ******************************************************************************************************
// ************** USB Callback Functions ****************************************************************
// ******************************************************************************************************
// The USB firmware stack will call the callback functions USBCBxxx() in response to certain USB related
// events.  For example, if the host PC is powering down, it will stop sending out Start of Frame (SOF)
// packets to your device.  In response to this, all USB devices are supposed to decrease their power
// consumption from the USB Vbus to <2.5mA* each.  The USB module detects this condition (which according
// to the USB specifications is 3+ms of no bus activity/SOF packets) and then calls the USBCBSuspend()
// function.  You should modify these callback functions to take appropriate actions for each of these
// conditions.  For example, in the USBCBSuspend(), you may wish to add code that will decrease power
// consumption from Vbus to <2.5mA (such as by clock switching, turning off LEDs, putting the
// microcontroller to sleep, etc.).  Then, in the USBCBWakeFromSuspend() function, you may then wish to
// add code that undoes the power saving things done in the USBCBSuspend() function.

// The USBCBSendResume() function is special, in that the USB stack will not automatically call this
// function.  This function is meant to be called from the application firmware instead.  See the
// additional comments near the function.

// Note *: The "usb_20.pdf" specs indicate 500uA or 2.5mA, depending upon device classification. However,
// the USB-IF has officially issued an ECN (engineering change notice) changing this to 2.5mA for all 
// devices.  Make sure to re-download the latest specifications to get all of the newest ECNs.

/******************************************************************************
 * Function:        void USBCBSuspend(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Call back that is invoked when a USB suspend is detected
 *
 * Note:            None
 *****************************************************************************/
void USBCBSuspend(void)
{
	//Example power saving code.  Insert appropriate code here for the desired
	//application behavior.  If the microcontroller will be put to sleep, a
	//process similar to that shown below may be used:
	
	//ConfigureIOPinsForLowPower();
	//SaveStateOfAllInterruptEnableBits();
	//DisableAllInterruptEnableBits();
	//EnableOnlyTheInterruptsWhichWillBeUsedToWakeTheMicro();	//should enable at least USBActivityIF as a wake source
	//Sleep();
	//RestoreStateOfAllPreviouslySavedInterruptEnableBits();	//Preferrably, this should be done in the USBCBWakeFromSuspend() function instead.
	//RestoreIOPinsToNormal();									//Preferrably, this should be done in the USBCBWakeFromSuspend() function instead.

	//IMPORTANT NOTE: Do not clear the USBActivityIF (ACTVIF) bit here.  This bit is 
	//cleared inside the usb_device.c file.  Clearing USBActivityIF here will cause 
	//things to not work as intended.	
	

 
}



/******************************************************************************
 * Function:        void USBCBWakeFromSuspend(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The host may put USB peripheral devices in low power
 *					suspend mode (by "sending" 3+ms of idle).  Once in suspend
 *					mode, the host may wake the device back up by sending non-
 *					idle state signalling.
 *					
 *					This call back is invoked when a wakeup from USB suspend 
 *					is detected.
 *
 * Note:            None
 *****************************************************************************/
void USBCBWakeFromSuspend(void)
{
	// If clock switching or other power savings measures were taken when
	// executing the USBCBSuspend() function, now would be a good time to
	// switch back to normal full power run mode conditions.  The host allows
	// 10+ milliseconds of wakeup time, after which the device must be 
	// fully back to normal, and capable of receiving and processing USB
	// packets.  In order to do this, the USB module must receive proper
	// clocking (IE: 48MHz clock must be available to SIE for full speed USB
	// operation).  
	// Make sure the selected oscillator settings are consistent with USB 
    // operation before returning from this function.
}

/********************************************************************
 * Function:        void USBCB_SOF_Handler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USB host sends out a SOF packet to full-speed
 *                  devices every 1 ms. This interrupt may be useful
 *                  for isochronous pipes. End designers should
 *                  implement callback routine as necessary.
 *
 * Note:            None
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
    // No need to clear UIRbits.SOFIF to 0 here.
    // Callback caller is already doing that.
}

/*******************************************************************
 * Function:        void USBCBErrorHandler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The purpose of this callback is mainly for
 *                  debugging during development. Check UEIR to see
 *                  which error causes the interrupt.
 *
 * Note:            None
 *******************************************************************/
void USBCBErrorHandler(void)
{
    // No need to clear UEIR to 0 here.
    // Callback caller is already doing that.

	// Typically, user firmware does not need to do anything special
	// if a USB error occurs.  For example, if the host sends an OUT
	// packet to your device, but the packet gets corrupted (ex:
	// because of a bad connection, or the user unplugs the
	// USB cable during the transmission) this will typically set
	// one or more USB error interrupt flags.  Nothing specific
	// needs to be done however, since the SIE will automatically
	// send a "NAK" packet to the host.  In response to this, the
	// host will normally retry to send the packet again, and no
	// data loss occurs.  The system will typically recover
	// automatically, without the need for application firmware
	// intervention.
	
	// Nevertheless, this callback function is provided, such as
	// for debugging purposes.
}


/*******************************************************************
 * Function:        void USBCBCheckOtherReq(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        When SETUP packets arrive from the host, some
 * 					firmware must process the request and respond
 *					appropriately to fulfill the request.  Some of
 *					the SETUP packets will be for standard
 *					USB "chapter 9" (as in, fulfilling chapter 9 of
 *					the official USB specifications) requests, while
 *					others may be specific to the USB device class
 *					that is being implemented.  For example, a HID
 *					class device needs to be able to respond to
 *					"GET REPORT" type of requests.  This
 *					is not a standard USB chapter 9 request, and 
 *					therefore not handled by usb_device.c.  Instead
 *					this request should be handled by class specific 
 *					firmware, such as that contained in usb_function_hid.c.
 *
 * Note:            None
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
    USBCheckCDCRequest();
}//end


/*******************************************************************
 * Function:        void USBCBStdSetDscHandler(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USBCBStdSetDscHandler() callback function is
 *					called when a SETUP, bRequest: SET_DESCRIPTOR request
 *					arrives.  Typically SET_DESCRIPTOR requests are
 *					not used in most applications, and it is
 *					optional to support this type of request.
 *
 * Note:            None
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
    // Must claim session ownership if supporting this request
}//end


/*******************************************************************
 * Function:        void USBCBInitEP(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called when the device becomes
 *                  initialized, which occurs after the host sends a
 * 					SET_CONFIGURATION (wValue not = 0) request.  This 
 *					callback function should initialize the endpoints 
 *					for the device's usage according to the current 
 *					configuration.
 *
 * Note:            None
 *******************************************************************/
void USBCBInitEP(void)
{
    //Enable the CDC data endpoints
    CDCInitEP();
}

/********************************************************************
 * Function:        void USBCBSendResume(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        The USB specifications allow some types of USB
 * 					peripheral devices to wake up a host PC (such
 *					as if it is in a low power suspend to RAM state).
 *					This can be a very useful feature in some
 *					USB applications, such as an Infrared remote
 *					control	receiver.  If a user presses the "power"
 *					button on a remote control, it is nice that the
 *					IR receiver can detect this signalling, and then
 *					send a USB "command" to the PC to wake up.
 *					
 *					The USBCBSendResume() "callback" function is used
 *					to send this special USB signalling which wakes 
 *					up the PC.  This function may be called by
 *					application firmware to wake up the PC.  This
 *					function will only be able to wake up the host if
 *                  all of the below are true:
 *					
 *					1.  The USB driver used on the host PC supports
 *						the remote wakeup capability.
 *					2.  The USB configuration descriptor indicates
 *						the device is remote wakeup capable in the
 *						bmAttributes field.
 *					3.  The USB host PC is currently sleeping,
 *						and has previously sent your device a SET 
 *						FEATURE setup packet which "armed" the
 *						remote wakeup capability.   
 *
 *                  If the host has not armed the device to perform remote wakeup,
 *                  then this function will return without actually performing a
 *                  remote wakeup sequence.  This is the required behavior, 
 *                  as a USB device that has not been armed to perform remote 
 *                  wakeup must not drive remote wakeup signalling onto the bus;
 *                  doing so will cause USB compliance testing failure.
 *                  
 *					This callback should send a RESUME signal that
 *                  has the period of 1-15ms.
 *
 * Note:            This function does nothing and returns quickly, if the USB
 *                  bus and host are not in a suspended condition, or are 
 *                  otherwise not in a remote wakeup ready state.  Therefore, it
 *                  is safe to optionally call this function regularly, ex: 
 *                  anytime application stimulus occurs, as the function will
 *                  have no effect, until the bus really is in a state ready
 *                  to accept remote wakeup. 
 *
 *                  When this function executes, it may perform clock switching,
 *                  depending upon the application specific code in 
 *                  USBCBWakeFromSuspend().  This is needed, since the USB
 *                  bus will no longer be suspended by the time this function
 *                  returns.  Therefore, the USB module will need to be ready
 *                  to receive traffic from the host.
 *
 *                  The modifiable section in this routine may be changed
 *                  to meet the application needs. Current implementation
 *                  temporary blocks other functions from executing for a
 *                  period of ~3-15 ms depending on the core frequency.
 *
 *                  According to USB 2.0 specification section 7.1.7.7,
 *                  "The remote wakeup device must hold the resume signaling
 *                  for at least 1 ms but for no more than 15 ms."
 *                  The idea here is to use a delay counter loop, using a
 *                  common value that would work over a wide range of core
 *                  frequencies.
 *                  That value selected is 1800. See table below:
 *                  ==========================================================
 *                  Core Freq(MHz)      MIP         RESUME Signal Period (ms)
 *                  ==========================================================
 *                      48              12          1.05
 *                       4              1           12.6
 *                  ==========================================================
 *                  * These timing could be incorrect when using code
 *                    optimization or extended instruction mode,
 *                    or when having other interrupts enabled.
 *                    Make sure to verify using the MPLAB SIM's Stopwatch
 *                    and verify the actual signal on an oscilloscope.
 *******************************************************************/
void USBCBSendResume(void)
{
    static WORD delay_count;
    
    //First verify that the host has armed us to perform remote wakeup.
    //It does this by sending a SET_FEATURE request to enable remote wakeup,
    //usually just before the host goes to standby mode (note: it will only
    //send this SET_FEATURE request if the configuration descriptor declares
    //the device as remote wakeup capable, AND, if the feature is enabled
    //on the host (ex: on Windows based hosts, in the device manager 
    //properties page for the USB device, power management tab, the 
    //"Allow this device to bring the computer out of standby." checkbox 
    //should be checked).
    if(USBGetRemoteWakeupStatus() == TRUE) 
    {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE)
        {
            USBMaskInterrupts();
            
            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0; 
            USBBusIsSuspended = FALSE;  //So we don't execute this code again, 
                                        //until a new suspend condition is detected.

            //Section 7.1.7.7 of the USB 2.0 specifications indicates a USB
            //device must continuously see 5ms+ of idle on the bus, before it sends
            //remote wakeup signalling.  One way to be certain that this parameter
            //gets met, is to add a 2ms+ blocking delay here (2ms plus at 
            //least 3ms from bus idle to USBIsBusSuspended() == TRUE, yeilds
            //5ms+ total delay since start of idle).
            delay_count = 3600U;        
            do
            {
                delay_count--;
            }while(delay_count);
            
            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do
            {
                delay_count--;
            }while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}


/*******************************************************************
 * Function:        void USBCBEP0DataReceived(void)
 *
 * PreCondition:    ENABLE_EP0_DATA_RECEIVED_CALLBACK must be
 *                  defined already (in usb_config.h)
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called whenever a EP0 data
 *                  packet is received.  This gives the user (and
 *                  thus the various class examples a way to get
 *                  data that is received via the control endpoint.
 *                  This function needs to be used in conjunction
 *                  with the USBCBCheckOtherReq() function since 
 *                  the USBCBCheckOtherReq() function is the apps
 *                  method for getting the initial control transfer
 *                  before the data arrives.
 *
 * Note:            None
 *******************************************************************/
#if defined(ENABLE_EP0_DATA_RECEIVED_CALLBACK)
void USBCBEP0DataReceived(void)
{
}
#endif

/*******************************************************************
 * Function:        BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *                        USB_EVENT event, void *pdata, WORD size)
 *
 * PreCondition:    None
 *
 * Input:           USB_EVENT event - the type of event
 *                  void *pdata - pointer to the event data
 *                  WORD size - size of the event data
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is called from the USB stack to
 *                  notify a user application that a USB event
 *                  occured.  This callback is in interrupt context
 *                  when the USB_INTERRUPT option is selected.
 *
 * Note:            None
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(int event, void *pdata, WORD size)
{
    switch(event)
    {
        case EVENT_TRANSFER:
            //Add application specific callback task or callback function here if desired.
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED: 
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:
            //Add application specific callback task or callback function here if desired.
            //The EVENT_TRANSFER_TERMINATED event occurs when the host performs a CLEAR
            //FEATURE (endpoint halt) request on an application endpoint which was 
            //previously armed (UOWN was = 1).  Here would be a good place to:
            //1.  Determine which endpoint the transaction that just got terminated was 
            //      on, by checking the handle value in the *pdata.
            //2.  Re-arm the endpoint if desired (typically would be the case for OUT 
            //      endpoints).
            break;
        default:
            break;
    }      
    return TRUE; 
}

/*******************************************************************
 * Function:        int RemoconOutData(
 *                        void )
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          int - A processing result is returned. 0 is normal.
 *
 * Side Effects:    None
 *
 * Overview:        ̊֐́AԊOR̃f[^o͂܂B    
 *                  o̓obt@[0]̃tH[}bg^Cv]A[1]ȍ~̃f[^o͂܂B 
 *                  0 is returned at the time of normal processing.
 *
 * Note:            None
 *******************************************************************/
int RemoconOutData(void)
{
	int ret_code = 0;
	int fi = 0;
	unsigned int byte_pos = 0;
	unsigned int bit_pos = 0;
	unsigned char send_bit = 0;
	unsigned char format_type;
	unsigned char out_buffer_offset;
	
	/* o͏ԂłȂ */
	if( 0 >= ui_out_on_time && 0 >= ui_out_off_time )
	{
		/* o͑҂ */
		if( uc_out_status == OUTSTATUS_OUTPUT_WAIT )
		{

			/*  */
			ui_out_pos = 0;	/* o͈ʒu */
			// tH[}bg^CvZbg
			format_type = uc_out_buff[0];
			
			/* o̓obt@ɏo̓f[^H */
			if( format_type != FORMATCODE_UNKNOWN )
			{
				/* ̏Ԃ */
				uc_out_status = OUTSTATUS_DATA_CODE;
				/* f[^TCYݒ(bit) */
				ui_send_bit_size = uc_out_buff[1];
				uc_send_bit_size_2nd_data = uc_out_buff[2];

				if( format_type == FORMATCODE_HITACH_AC )		// GAȐꍇ
					ui_send_bit_size = uc_out_buff[1] + 256;	// 256ĕۑĂ̂ŁAŖ߂
				
				// PWM Duty Set
				ClosePWM1();
				if(format_type == FORMATCODE_DAIKIN && ui_send_bit_size == 0x38)
				{	// 33kHz
					ui_PWM50_Set_Val = PWM_50_33k;
					OpenPWM1(PWM_PERIOD_33k);
				}
				else if(format_type == FORMATCODE_SONY)
				{	// 40kHz
					ui_PWM50_Set_Val = PWM_50_40k;
					OpenPWM1(PWM_PERIOD_40k);
				}
				else
				{	// 38kHz
					ui_PWM50_Set_Val = PWM_50;
					OpenPWM1(PWM_PERIOD);
				}
					
				
				/* ONOFFԂZbg*/
//				/* ƓdtH[}bg */
//				if( format_type == FORMATCODE_KADEN )
				/* GAR܂߂ƓdtH[}bg */
				if(( format_type == FORMATCODE_KADEN ) || ( format_type == FORMATCODE_HITACH_AC ))
				{
					ui_out_on_time = READERCODE_ON_KADEN;
					ui_out_off_time = READERCODE_OFF_KADEN;
					
					uc_out_data0_on = DATA0_ON_KADEN;
					uc_out_data0_off = DATA0_OFF_KADEN;
					uc_out_data1_on = DATA1_ON_KADEN;
					uc_out_data1_off = DATA1_OFF_KADEN;
				}
				/* TMYtH[}bg(ƓdtH[}bg) */
				else if( format_type == FORMATCODE_TMY )
				{
					ui_out_on_time = READERCODE_ON_KADEN;
					ui_out_off_time = READERCODE_OFF_KADEN;
					
					uc_out_data0_on = DATA0_ON_KADEN;
					uc_out_data0_off = DATA0_OFF_KADEN;
					uc_out_data1_on = DATA1_ON_KADEN;
					uc_out_data1_off = DATA1_OFF_TMY;
				}
				/* ۑPd@tH[}bg */
				else if( format_type == FORMATCODE_LUCKY )
				{
					ui_out_on_time = READERCODE_ON_LUCKY;
					ui_out_off_time = READERCODE_OFF_LUCKY;
					
					uc_out_data0_on = DATA0_ON_LUCKY;
					uc_out_data0_off = DATA0_OFF_LUCKY;
					uc_out_data1_on = DATA1_ON_LUCKY;
					uc_out_data1_off = DATA1_OFF_LUCKY;
				}
				/* (Om)tH[}bg */
				else if( format_type == FORMATCODE_HITACHI )
				{
					ui_out_on_time = READERCODE_ON_HITACHI;
					ui_out_off_time = READERCODE_OFF_HITACHI;
					
					uc_out_data0_on = DATA0_ON_NEC;
					uc_out_data0_off = DATA0_OFF_NEC;
					uc_out_data1_on = DATA1_ON_NEC;
					uc_out_data1_off = DATA1_OFF_NEC;
				}
				/* (GAR)tH[}bg */
				else if( format_type == FORMATCODE_TOSHIBA )
				{
					ui_out_on_time = READERCODE_ON_TOSHIBA;
					ui_out_off_time = READERCODE_OFF_TOSHIBA;
					
					uc_out_data0_on = DATA0_ON_TOSHIBA;
					uc_out_data0_off = DATA0_OFF_TOSHIBA;
					uc_out_data1_on = DATA1_ON_TOSHIBA;
					uc_out_data1_off = DATA1_OFF_TOSHIBA;
				}
				/*ŃGARWX-F01EtH[}bg */
				else if( format_type == FORMATCODE_TOSHIB_WXF )
				{
					ui_out_on_time = READERCODE_ON_TOSHIB_WXF;
					ui_out_off_time = READERCODE_OFF_TOSHIB_WXF;
					
					uc_out_data0_on = DATA0_ON_TOSHIB_WXF;
					uc_out_data0_off = DATA0_OFF_TOSHIB_WXF;
					uc_out_data1_on = DATA1_ON_TOSHIB_WXF;
					uc_out_data1_off = DATA1_OFF_TOSHIB_WXF;
				}
				/* NECtH[}bg */
				else if( format_type == FORMATCODE_NEC )
				{
					ui_out_on_time = READERCODE_ON_NEC;
					ui_out_off_time = READERCODE_OFF_NEC;
					
					uc_out_data0_on = DATA0_ON_NEC;
					uc_out_data0_off = DATA0_OFF_NEC;
					uc_out_data1_on = DATA1_ON_NEC;
					uc_out_data1_off = DATA1_OFF_NEC;
				}
				/* SONYtH[}bg */
				else if( format_type == FORMATCODE_SONY )
				{
					ui_out_on_time = READERCODE_ON_SONY;
					ui_out_off_time = READERCODE_OFF_SONY;
					
					uc_out_data0_on = DATA0_ON_SONY;
					uc_out_data0_off = DATA0_OFF_SONY;
					uc_out_data1_on = DATA1_ON_SONY;
					uc_out_data1_off = DATA1_OFF_SONY;
				}
				/* MITSUBISHItH[}bg */
				else if( format_type == FORMATCODE_MITSU )
				{
					/* [_R[hȂ */
					ui_out_on_time = 0;
					ui_out_off_time = 0;
					
					uc_out_data0_on = DATA0_ON_M;
					uc_out_data0_off = DATA0_OFF_M;
					uc_out_data1_on = DATA1_ON_M;
					uc_out_data1_off = DATA1_OFF_M;
				}
				/* DAIKINtH[}bg */
				else if( format_type == FORMATCODE_DAIKIN )
				{
					ui_out_on_time = READERCODE_ON_DAI;
					ui_out_off_time = READERCODE_OFF_DAI;
					
					uc_out_data0_on = DATA0_ON_DAI;
					uc_out_data0_off = DATA0_OFF_DAI;
					uc_out_data1_on = DATA1_ON_DAI;
					uc_out_data1_off = DATA1_OFF_DAI;
				}
				/* DAIKIN2tH[}bg */
				else if( format_type == FORMATCODE_DAIKIN2 )
				{
					ui_out_on_time = READERCODE_ON_DAI2;
					ui_out_off_time = READERCODE_OFF_DAI2;
					
					uc_out_data0_on = DATA0_ON_DAI;
					uc_out_data0_off = DATA0_OFF_DAI;
					uc_out_data1_on = DATA1_ON_DAI;
					uc_out_data1_off = DATA1_OFF_DAI;
				}
				/* tH[}bgs */
				else
				{
					/* o̓obt@NA */
					for( fi = 0; fi < OUTBUFFER_SIZE_EX; fi++ )
					{
						uc_out_buff[fi] = 0;
					}
					uc_out_status = OUTSTATUS_OUTPUT_WAIT;
					ui_send_bit_size = 0;
					uc_send_bit_size_2nd_data = 0;
					format_type = 0;
				}
			}
		}
		else if( uc_out_status == OUTSTATUS_DATA_CODE )
		{
			// tH[}bg^CvZbg
			format_type = uc_out_buff[0];
			out_buffer_offset = OUTBUFFER_SIZE_EX - OUTBUFFER_DATA_AREA_SIZE_EX;

			byte_pos = ui_out_pos / 8;
			bit_pos = ui_out_pos % 8;
			
			if ( ( ui_out_pos == (unsigned int)ui_send_bit_size && uc_send_bit_size_2nd_data == 0 ) || ui_out_pos > DATA_MAX_BITS )
			{	/* IR[h */
				send_bit = 0xF0;
			}
			else if(ui_out_pos == (unsigned int)ui_send_bit_size && uc_send_bit_size_2nd_data > 0)
			{	/* 2ndf[^ */
				send_bit = 3;
			}	
			else if( 0 <= (byte_pos+out_buffer_offset) && (byte_pos+out_buffer_offset) < OUTBUFFER_SIZE_EX )
			{
				send_bit = (uc_out_buff[byte_pos+out_buffer_offset] >> bit_pos ) & 0x01;
			}
			else
			{	/* G[ */
				send_bit = 0xFF;
			}	

			if( send_bit == 0 )
			{	/* DATA0o */
				ui_out_on_time = uc_out_data0_on;
				ui_out_off_time = uc_out_data0_off;
			}
			else if ( send_bit == 1 )
			{	/* DATA1o */
				ui_out_on_time = uc_out_data1_on;
				ui_out_off_time = uc_out_data1_off;
			}
			else if ( send_bit == 0xF0 )
			{	/* IR[ho */
				ui_out_on_time = uc_out_data0_on;
				ui_out_off_time = SENDCODE_END_CNT;
			}
			else if ( send_bit == 3 )
			{	/* ̃f[^܂ł̊Ԋu󂯂 */
				if( format_type == FORMATCODE_SONY )
				{	/* SONYtH[}bg̏ꍇAɏ̊Ԋu󂯏IĂ̂łł͉Ȃ */
					ui_out_on_time = 0;
					ui_out_off_time = 0;
				}
				else
				{
					ui_out_on_time = uc_out_data0_on;
					ui_out_off_time = DATA_CODE_INTERVAL_SEND_CNT;

					if(format_type == FORMATCODE_TOSHIB_WXF)
						ui_out_off_time = DATA_CODE_INTERVAL_SEND_CNT_TOSHIB_WXF;
				}
				
				// [_R[hMԂ
				uc_out_status = OUTSTATUS_2ND_READER_CODE;
			}
			else if ( send_bit == 0xFF )
			{	/* G[ */
				ui_out_on_time = 0;
				ui_out_off_time = 0;
				uc_out_status = OUTSTATUS_OUTPUT_WAIT;
			}
			
			/* SONYtH[}bg̓g[[R[hȂ */
			if( format_type == FORMATCODE_SONY )
			{
				//ŏIf[^MOFF𒷂
				if ( ui_out_pos == (unsigned int)(ui_send_bit_size - 1) )
				{	/* IR[h */
//					ui_out_off_time = SENDCODE_END_CNT;
					ui_out_off_time = DATA_CODE_INTERVAL_SEND_CNT_SONY;	// 200260炢̕(ƂR)
				}	
			}
				
			if( send_bit >= 0xF0 )
			{	/* ̑Mf[^Ȃ */
				/* o̓obt@NA */
/*				for( fi = 0; fi < OUTBUFFER_SIZE_EX; fi++ )
				{
					uc_out_buff[fi] = 0;
				}*/
				uc_out_buff[0] = 0;		// o̓obt@SNA͏dĔg`̂ŏɗp擪NA
				/* o͑҂ */
				uc_out_status = OUTSTATUS_OUTPUT_WAIT;
			}
			else if(send_bit == 0 || send_bit == 1)
			{
				/* o̓f[^ʒuCNg */
				ui_out_pos++;
			}
		}
		else if( uc_out_status == OUTSTATUS_2ND_READER_CODE )
		{	// 2nd Reader Codeo

			uc_out_status = OUTSTATUS_2ND_DATA_CODE;
			
			// tH[}bg^CvZbg
			format_type = uc_out_buff[0];
			out_buffer_offset = OUTBUFFER_SIZE_EX - OUTBUFFER_DATA_AREA_SIZE_EX;
			
			/* ƓdtH[}bg */
			if( format_type == FORMATCODE_KADEN )
			{
				ui_out_on_time = READERCODE_ON_KADEN;
				ui_out_off_time = READERCODE_OFF_KADEN;
			}
			/* (Om)tH[}bg */
			else if( format_type == FORMATCODE_HITACHI )
			{
				ui_out_on_time = READERCODE_ON_HITACHI;
				ui_out_off_time = READERCODE_OFF_HITACHI;
			}
			/* (GAR)tH[}bg */
			else if( format_type == FORMATCODE_TOSHIBA )
			{
				ui_out_on_time = READERCODE_ON_TOSHIBA;
				ui_out_off_time = READERCODE_OFF_TOSHIBA;
			}
			/* ŃGARWX-F01EtH[}bg */
			else if( format_type == FORMATCODE_TOSHIB_WXF )
			{
				ui_out_on_time = READERCODE_ON_TOSHIB_WXF;
				ui_out_off_time = READERCODE_OFF_TOSHIB_WXF;
			}
			/* NECtH[}bg */
			else if( format_type == FORMATCODE_NEC )
			{
				ui_out_on_time = READERCODE_ON_NEC;
				ui_out_off_time = READERCODE_OFF_NEC;
			}
			/* SONYtH[}bg */
			else if( format_type == FORMATCODE_SONY )
			{
				ui_out_on_time = READERCODE_ON_SONY;
				ui_out_off_time = READERCODE_OFF_SONY;
			}
#if 0
			/* MITSUBISHItH[}bg */
			else if( format_type == FORMATCODE_MITSU )
			{
				/* [_R[hȂ */
				ui_out_on_time = 0;
				ui_out_off_time = 0;
			}
#endif
			/* DAIKINtH[}bg */
			else if( format_type == FORMATCODE_DAIKIN )
			{
				ui_out_on_time = READERCODE_ON_DAI;
				ui_out_off_time = READERCODE_OFF_DAI;
			}
			/* DAIKIN2tH[}bg */
			else if( format_type == FORMATCODE_DAIKIN2 )
			{
				ui_out_on_time = READERCODE_ON_DAI2;
				ui_out_off_time = READERCODE_OFF_DAI2;
			}
			/* tH[}bgs */
			else
			{
				/* o̓obt@NA */
				for( fi = 0; fi < OUTBUFFER_SIZE_EX; fi++ )
				{
					uc_out_buff[fi] = 0;
				}
				uc_out_status = OUTSTATUS_OUTPUT_WAIT;
				ui_send_bit_size = 0;
				uc_send_bit_size_2nd_data = 0;
				format_type = 0;
			}
		}
		else if( uc_out_status == OUTSTATUS_2ND_DATA_CODE )
		{	// 2nd Data Codeo

			// tH[}bg^CvZbg
			format_type = uc_out_buff[0];
			out_buffer_offset = OUTBUFFER_SIZE_EX - OUTBUFFER_DATA_AREA_SIZE_EX;
				
			byte_pos = ui_out_pos / 8;
			bit_pos = ui_out_pos % 8;
			
			if ( ui_out_pos == (unsigned int)(ui_send_bit_size + uc_send_bit_size_2nd_data) || ui_out_pos > DATA_MAX_BITS )
			{	/* IR[h */
				send_bit = 0xF0;
			}
			else if( 0 <= (byte_pos+out_buffer_offset) && (byte_pos+out_buffer_offset) < OUTBUFFER_SIZE_EX )
			{
				send_bit = (uc_out_buff[byte_pos+out_buffer_offset] >> bit_pos ) & 0x01;
			}
			else
			{	/* G[ */
				send_bit = 0xFF;
			}	

			if( send_bit == 0 )
			{	/* DATA0o */
				ui_out_on_time = uc_out_data0_on;
				ui_out_off_time = uc_out_data0_off;
			}
			else if ( send_bit == 1 )
			{	/* DATA1o */
				ui_out_on_time = uc_out_data1_on;
				ui_out_off_time = uc_out_data1_off;
			}
			else if ( send_bit == 0xF0 )
			{
				if( format_type == FORMATCODE_SONY )
				{	/* SONYtH[}bg̏ꍇ͉Ȃ */
					ui_out_on_time = 0;
					ui_out_off_time = 0;
				}
				else
				{	/* IR[ho */
					ui_out_on_time = uc_out_data0_on;
					ui_out_off_time = SENDCODE_END_CNT;
				}
			}
			else if ( send_bit == 0xFF )
			{	/* G[ */
				ui_out_on_time = 0;
				ui_out_off_time = 0;
				uc_out_status = OUTSTATUS_OUTPUT_WAIT;
			}

			if( send_bit >= 0xF0 )
			{	/* ̑Mf[^Ȃ */
				/* o̓obt@NA */
/*				for( fi = 0; fi < OUTBUFFER_SIZE_EX; fi++ )
				{
					uc_out_buff[fi] = 0;
				}*/
				uc_out_buff[0] = 0;		// o̓obt@SNA͏dĔg`̂ŏɗp擪NA
				/* o͑҂ */
				uc_out_status = OUTSTATUS_OUTPUT_WAIT;
			}
			/* o̓f[^ʒuCNg */
			ui_out_pos++;
		}				
	}

	/* oON */
	if( 0 < ui_out_on_time )
	{
		SetDCPWM1(ui_PWM50_Set_Val);
		//SetDCPWM1(PWM_50);
		ui_out_on_time--;
mLED_4_On();
	}
	/* oOFF */
	else if( 0 < ui_out_off_time )
	{
		SetDCPWM1(PWM_OFF);
		ui_out_off_time--;
	}
	else
	{
		SetDCPWM1(PWM_OFF);
mLED_4_Off();
	}

    return ret_code; 
}

/******************************************************************************
 * Function:        unsigned char ToDec(const char s[])
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          unsigned char x - converted number
 *
 * Side Effects:    None
 *
 * Overview:        Convert hexadecimal formated string to number.
 *
 * Note:            
 *
 *****************************************************************************/
unsigned char ToDec (const char s[])
{
	int i = 0;
	int n;
	unsigned char x = 0;

	while (s[i] != '\0') {		// ̖łȂ

		// '0'  '9' ̕Ȃ
		if ('0' <= s[i] && s[i] <= '9')
			n = s[i] - '0';		// ɕϊ

		// 'A'  'F' ̕Ȃ 
		else if ('A' <= s[i] && s[i] <= 'F')
			n = s[i] - 'A' + 10;		// ɕϊ

		else
		{	// ȊO̕Ȃ
			;
		}
		i++;		// ̕w

		x = x *16 + n;		// オ
	}
	return (x);
}

/** EOF main.c *************************************************/
